unit UfrmExemploTList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Mask;

type
  TfrmExemploTLista = class(TForm)
    btnCriaLista: TButton;
    btnAdicionaItem: TButton;
    btnContaItens: TButton;
    btnPercorreItens: TButton;
    btnTransfItens: TButton;
    lstbxItemsLista: TListBox;
    btnRemoveItem: TButton;
    edtIndice: TEdit;
    btnDestroiLista: TButton;
    cbxTipoItem: TComboBox;
    procedure btnCriaListaClick(Sender: TObject);
    procedure btnAdicionaItemClick(Sender: TObject);
    procedure btnContaItensClick(Sender: TObject);
    procedure btnPercorreItensClick(Sender: TObject);
    procedure btnTransfItensClick(Sender: TObject);
    procedure btnRemoveItemClick(Sender: TObject);
    procedure edtIndiceKeyPress(Sender: TObject; var Key: Char);
    procedure btnDestroiListaClick(Sender: TObject);
  private
    { Private declarations }
    MyList : TList;
  public
    { Public declarations }
  end;
var
  frmExemploTLista: TfrmExemploTLista;

implementation

{$R *.dfm}

procedure TfrmExemploTLista.btnCriaListaClick(Sender: TObject);
begin
  MyList := TList.Create;
end;

procedure TfrmExemploTLista.btnAdicionaItemClick(Sender: TObject);
var
  pComp : TObject;
begin
  if MyList <> Nil then
     begin
       if cbxTipoItem.ItemIndex = 0 then
          pComp := TEdit.Create(Self)
       else
       if cbxTipoItem.ItemIndex = 1 then
          pComp := TCombobox.Create(Self)
       else
       if cbxTipoItem.ItemIndex = 2 then
          pComp := TButton.Create(Self);
       MyList.Add(pComp);
     end
  else
     Showmessage('A Lista ainda no foi criada');
end;

procedure TfrmExemploTLista.btnContaItensClick(Sender: TObject);
var
  i : Integer;
begin
  if MyList <> nil then
     begin
       i := MyList.Count;
       Showmessage('Existe(m) '+ IntToStr(I) + ' item(ns) na lista!');
     end;
end;

procedure TfrmExemploTLista.btnPercorreItensClick(Sender: TObject);
var
  I : Integer;
  pComp : TObject;
begin
  if MyList <> nil then
     begin
        for I := 0 to MyList.Count-1 do
          begin
            pComp := TObject(MyList.Items[I]);
            Showmessage(pComp.ClassName);
          end;
     end;
end;

procedure TfrmExemploTLista.btnTransfItensClick(Sender: TObject);
var
  I : Integer;
begin
  lstbxItemsLista.Clear; //Limpa o ListBox
  if MyList <> nil then
     begin
        for I := 0 to MyList.Count-1 do
          begin
            lstbxItemsLista.Items.Add(TObject(MyList.Items[I]).ClassName);
          end;
     end;
end;

procedure TfrmExemploTLista.btnRemoveItemClick(Sender: TObject);
var
  idx : Integer;
begin
  idx := StrToInt(edtIndice.Text);
  if idx > MyList.Count-1 then
     Showmessage('O ndice informado no existe!')
  else
    begin
      MyList.Delete(idx);
      btnTransfItensClick(Sender);
      edtIndice.Clear;
    end;
end;

procedure TfrmExemploTLista.edtIndiceKeyPress(Sender: TObject;
  var Key: Char);
begin
  if not (key in ['0'..'9',#8]) then
     key := #0;
end;

procedure TfrmExemploTLista.btnDestroiListaClick(Sender: TObject);
var
  I : Integer;
begin
  if MyList <> nil then
     begin
       lstbxItemsLista.Clear;
       for I := 0 to MyList.Count-1 do
         begin
           TObject(MyList.Items[I]).Free;
         end;
       MyList.Free;
       MyList := nil;
     end;
end;

end.
